#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20100216

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)


#ifndef yyparse
#define yyparse    parserparse
#endif /* yyparse */

#ifndef yylex
#define yylex      parserlex
#endif /* yylex */

#ifndef yyerror
#define yyerror    parsererror
#endif /* yyerror */

#ifndef yychar
#define yychar     parserchar
#endif /* yychar */

#ifndef yyval
#define yyval      parserval
#endif /* yyval */

#ifndef yylval
#define yylval     parserlval
#endif /* yylval */

#ifndef yydebug
#define yydebug    parserdebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    parsernerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  parsererrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      parserlhs
#endif /* yylhs */

#ifndef yylen
#define yylen      parserlen
#endif /* yylen */

#ifndef yydefred
#define yydefred   parserdefred
#endif /* yydefred */

#ifndef yydgoto
#define yydgoto    parserdgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   parsersindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   parserrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   parsergindex
#endif /* yygindex */

#ifndef yytable
#define yytable    parsertable
#endif /* yytable */

#ifndef yycheck
#define yycheck    parsercheck
#endif /* yycheck */

#ifndef yyname
#define yyname     parsername
#endif /* yyname */

#ifndef yyrule
#define yyrule     parserrule
#endif /* yyrule */
#define YYPREFIX "parser"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
#ifdef YYPARSE_PARAM_TYPE
#define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
#else
#define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
#endif
#else
#define YYPARSE_DECL() yyparse(void)
#endif /* YYPARSE_PARAM */

extern int YYPARSE_DECL();

#line 30 "src/parser.y"

#include <QDir>
#include <QFile>
#include <QFileInfo>
#include <QTextStream>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "module.h"
#include "expression.h"
#include "value.h"
#include "function.h"
#include "printutils.h"

int parser_error_pos = -1;

int parserlex(void);
void yyerror(char const *s);

int lexerget_lineno(void);
int lexerlex_destroy(void);
int lexerlex(void);

QVector<Module*> module_stack;
Module *module;

class ArgContainer {
public:
	QString argname;
	Expression *argexpr;
};
class ArgsContainer {
public:
	QVector<QString> argnames;
	QVector<Expression*> argexpr;
};

#line 71 "src/parser.y"
typedef union {
	char *text;
	double number;
	class Value *value;
	class Expression *expr;
	class ModuleInstantiation *inst;
	class IfElseModuleInstantiation *ifelse;
	class ArgContainer *arg;
	class ArgsContainer *args;
} YYSTYPE;
#line 165 "parser.tab.c"
#define TOK_MODULE 257
#define TOK_FUNCTION 258
#define TOK_IF 259
#define TOK_ELSE 260
#define TOK_ID 261
#define TOK_STRING 262
#define TOK_USE 263
#define TOK_NUMBER 264
#define TOK_TRUE 265
#define TOK_FALSE 266
#define TOK_UNDEF 267
#define LE 268
#define GE 269
#define EQ 270
#define NE 271
#define AND 272
#define OR 273
#define YYERRCODE 256
static const short parserlhs[] = {                       -1,
    0,   13,    0,    0,   15,   15,   14,   14,   14,   14,
   17,   14,   18,   14,    6,    6,    4,    5,    5,    3,
    3,    3,    7,    7,    8,    8,    8,    8,    8,    8,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,   16,   16,    2,    2,   10,   10,   10,   12,   12,
    9,    9,    9,   11,   11,
};
static const short parserlen[] = {                        2,
    0,    0,    3,    2,    0,    2,    1,    3,    1,    4,
    0,    8,    0,   10,    1,    3,    5,    1,    3,    2,
    2,    1,    0,    2,    4,    3,    2,    2,    2,    2,
    1,    1,    1,    1,    3,    1,    1,    5,    7,    3,
    4,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    2,    2,    2,    3,    5,    4,
    4,    2,    0,    1,    4,    0,    1,    4,    1,    3,
    0,    1,    4,    1,    3,
};
static const short parserdefred[] = {                     0,
    0,    0,    0,    0,    2,    0,    0,    0,    7,    0,
    0,    0,    9,    0,   22,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   27,   30,   29,    0,    0,
   28,    0,   20,   23,   15,   21,    4,    0,    0,    0,
   36,   37,   31,   32,   33,    0,    0,    0,    0,    0,
    0,   26,    0,    0,    0,    0,   72,    3,    6,    8,
   19,    0,    0,    0,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   10,    0,   25,    0,   16,   24,    0,    0,
    0,    0,    0,   62,    0,    0,    0,   40,   58,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   35,   17,    0,    0,    0,    0,
   11,    0,   61,    0,    0,   41,    0,   60,   73,   68,
    0,    0,    0,   38,    0,    0,   12,    0,    0,    0,
   39,   14,
};
static const short parserdgoto[] = {                     12,
   55,   73,   13,   14,   15,   36,   62,   16,   56,   64,
   57,   65,   24,   17,   30,   74,  141,  150,
};
static const short parsersindex[] = {                   726,
 -245, -241,  -13,  120,    0,   -5,   -5,   -5,    0,  826,
   -5,    0,    0, -221,    0,  -18,  726,   11,   13,  456,
   -5,  456,  482,  726,  -29,    0,    0,    0,  826,  -68,
    0,  455,    0,    0,    0,    0,    0, -203, -203,   42,
    0,    0,    0,    0,    0,  456,  456,  456,  373,  456,
  122,    0,  129,   15,  241,   34,    0,    0,    0,    0,
    0,  523,   22,   50,    0,   50,  482,  104,  104,  104,
   60,  156,   62,   20,  163,  456,  456,  456,  456,  456,
  456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
 -144,  455,    0,  456,    0,   60,    0,    0,  456,   60,
   80,   81,   36,    0,  456,   60,   37,    0,    0,  305,
  305,  339,  339,  440,  407,  203,  305,  305,  104,  104,
  -32,  -32,  -32,  312,    0,    0,  241,  482,  241, -203,
    0,   70,    0,   65,  456,    0,  456,    0,    0,    0,
  826,  456,  456,    0,  241,  241,    0,  241,  400,   73,
    0,    0,
};
static const short parserrindex[] = {                   140,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   23,
    0,    0,    0,    1,    0,    0,  140,    0,    0,    0,
    0,    0,   40,  140,    0,    0,    0,    0,   23,    0,
    0,    0,    0,    0,    0,    0,    0,   47,   47,  -37,
    0,    0,    0,    0,    0,    0,    0,    0,   64,    0,
    0,    0,    0,   92,   51,    0,    0,    0,    0,    0,
    0,    0,  101,  112,    0,  112,   40,  508,  548,  554,
  275,  -41,   64,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  505,    0,    0,    0,  -39,
    0,    0,    0,    0,    0,  425,    0,    0,    0,  694,
  742,  561,  671,  248,  592,    0,  748,  795,  601,  639,
    3,   27,   56,    0,    0,    0,  136,    0,  146,  132,
    0,    0,    0,    0,   77,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -26,  103,    0,  127,    0,    0,
    0,    0,
};
static const short parsergindex[] = {                    18,
  951,    0,   17,    0,    0,  -19,    0,  231,  130,  155,
   79,   49,    0,    2,  182,  818,    0,    0,
};
#define YYTABLESIZE 1094
static const short parsertable[] = {                     34,
   18,   63,   64,   34,   34,   34,   34,   34,   34,   34,
   23,   29,   61,   91,    6,   18,   11,   65,    8,   19,
   34,   34,   34,    7,   34,   34,   20,    6,   21,   11,
   29,    8,   35,   18,   37,   18,    7,   18,   32,   42,
   33,   58,   18,   42,   42,   42,   42,   42,   35,   42,
   38,   64,   39,   34,   67,   34,   60,   63,   90,   18,
   42,   42,   42,   43,   42,   42,   65,   43,   43,   43,
   43,   43,  126,   43,   95,   94,  133,   96,   98,   96,
   71,   67,   99,   71,   43,   43,   43,   66,   43,   43,
   66,   74,   44,  100,   74,   42,   44,   44,   44,   44,
   44,   89,   44,   71,   34,  106,   87,   85,   35,   86,
   91,   88,  108,   44,   44,   44,  125,   44,   44,   43,
  131,  132,  143,   18,   83,   18,   84,   82,   34,  136,
  142,  152,   34,   34,   34,   34,   34,   34,   34,    1,
   89,   69,  147,   59,   69,   87,   59,    5,   44,   91,
   88,   34,   63,   34,   34,   90,   63,  144,   89,   23,
   59,   59,   92,   87,   85,   89,   86,   91,   88,   62,
   87,   85,   62,   86,   91,   88,   75,   21,  140,   75,
   22,   83,   34,   84,   82,   13,   70,   93,   83,   70,
   84,   82,   89,   66,   90,   59,  103,   87,   85,   89,
   86,   91,   88,  109,   87,   85,  139,   86,   91,   88,
   59,    0,   90,  105,    0,   83,    0,   84,   82,   90,
    0,   63,   83,    0,   84,   82,    0,    0,    0,    0,
   34,   34,   34,   34,   34,   34,   26,   27,   28,   89,
    3,   31,   25,    0,   87,   85,   90,   86,   91,   88,
    0,   52,    0,   90,    0,   25,    0,   18,   18,   18,
  137,   18,   83,   18,   84,   82,    0,    0,    0,    0,
   42,   42,   42,   42,   42,   42,    0,   89,    0,    0,
    0,    0,   87,   85,    0,   86,   91,   88,   53,    0,
    0,   53,    0,   90,   43,   43,   43,   43,   43,   43,
   83,    0,   84,   82,    0,   53,   53,   63,    0,    0,
   53,    0,    0,    0,   63,   63,    0,   63,    0,   63,
    0,    0,    0,   44,   44,   44,   44,   44,   44,    0,
    0,   90,   76,   77,   78,   79,   80,   81,    0,    0,
   53,   89,    0,    0,    0,    0,   87,   85,   89,   86,
   91,   88,    0,   87,   85,    0,   86,   91,   88,   34,
   34,   34,   34,   34,   34,   63,    0,   63,    0,    0,
    0,   83,    0,   84,   82,   89,    0,    0,    0,    0,
   87,   85,    0,   86,   91,   88,    0,    0,    0,   76,
   77,   78,   79,   80,   81,   90,   76,   77,   78,   79,
   80,   81,   90,    0,  138,   46,    0,    0,    0,    0,
    0,    0,   50,    0,    0,   47,   71,   48,    0,    0,
    0,    0,    0,   76,   77,   78,   79,   80,   81,   90,
   76,   77,   78,   79,   80,   81,   89,    0,    0,    0,
    0,   87,   85,   89,   86,   91,   88,    0,   87,   85,
    0,   86,   91,   88,    0,    0,    0,   63,    0,   83,
    0,   84,   82,   49,   63,    0,   83,   63,   84,   63,
   76,   77,   78,   79,   80,   81,   89,    0,    0,    0,
    0,   87,   85,    0,   86,   91,   88,    6,   46,   11,
   90,    8,  151,    0,    0,   50,    7,   90,   47,   83,
   48,   84,    0,    0,    0,    0,    0,    0,   76,   77,
   78,   79,   80,   81,   46,   63,    0,   63,    0,   53,
   53,   50,    0,    0,   47,    0,   48,    0,    0,    0,
   90,    0,    0,    0,    0,   63,   63,   63,   63,   63,
   63,   63,    0,    0,   63,    0,   49,   63,   57,   63,
   57,   57,   57,    0,    0,    6,    0,   11,    0,    8,
    0,    0,    0,    0,    7,   57,   57,   57,    0,   57,
   57,    0,   49,    0,   78,   79,    0,   34,    0,   76,
   77,   78,   79,   80,   81,    0,    0,    0,   55,    0,
   55,   55,   55,    0,   56,   63,   56,   56,   56,    0,
   57,   49,    0,    0,   49,   55,   55,   55,    0,   55,
   55,   56,   56,   56,    0,   56,   56,    0,   49,   49,
   49,    0,   49,   49,    0,    0,    0,    0,    0,    0,
    0,    0,   54,   40,   41,   54,   42,   43,   44,   45,
   55,   45,    0,   45,   45,   45,   56,   97,    0,   54,
   54,    0,    0,   49,   54,    0,    0,    0,   45,   45,
   45,    0,   45,   45,    0,    0,    0,   76,   77,   78,
   79,   80,   81,    0,   76,   77,   78,   79,   80,   46,
    0,   46,   46,   46,   54,   63,   63,    0,   63,   63,
   63,   63,    0,   45,    0,    0,   46,   46,   46,    0,
   46,   46,    0,    0,    0,    0,    0,   76,   77,   78,
   79,   50,    0,    3,   50,   25,   40,   41,    0,   42,
   43,   44,   45,    0,    0,    0,    0,    0,   50,   50,
   50,   46,   50,   50,   48,    0,    0,   48,    0,    0,
    0,    0,   54,   41,    0,   42,   43,   44,   45,    0,
    0,   48,   48,   48,    0,   48,   48,    0,    6,    0,
   11,    0,    8,   50,    0,   63,   63,    7,   63,   63,
   63,   63,    0,    0,    0,   57,   57,   57,   57,   57,
   57,    3,   51,   25,    9,   51,   48,    0,   47,    0,
    0,   47,    0,    0,    0,    0,    0,    0,    0,   51,
   51,   51,    0,   51,   51,   47,   47,   47,    0,   47,
   47,    0,    0,    0,    0,   55,   55,   55,   55,   55,
   55,   56,   56,   56,   56,   56,   56,    0,   49,   49,
   49,   49,   49,   49,   51,   52,    0,    0,   52,    0,
   47,    0,    0,    0,    0,    0,    0,    0,   10,    0,
    0,    0,   52,   52,   52,    0,   52,   52,    6,    0,
   11,    0,    8,    0,   54,    0,    0,    7,   45,   45,
   45,   45,   45,   45,    0,    0,    0,    0,    0,    0,
    0,  101,    0,  102,    9,    0,    0,   52,  104,    0,
  107,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   46,   46,   46,   46,
   46,   46,    0,  128,    0,    0,    0,  130,    0,    0,
    0,    0,    0,  135,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   50,   50,
   50,   50,   50,   50,    0,    0,    0,    0,   10,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   48,   48,    0,    0,   48,   48,    0,    0,    0,
   51,    0,   53,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    2,    3,    0,    4,    0,    5,    0,
    0,    0,    0,    0,    0,    0,   68,   69,   70,   72,
   75,    0,    0,    0,    0,    0,    0,    0,    0,   51,
   51,    0,    0,   51,   51,   47,   47,    0,    0,   47,
   47,    0,    0,    0,    0,    0,  110,  111,  112,  113,
  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
  124,    0,    0,    0,  127,    0,    0,    0,    0,  129,
    0,    0,    0,    0,    0,  134,    0,    0,    0,    0,
    0,    0,   52,   52,    0,    0,   52,   52,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    2,    3,  145,    4,  146,    0,    0,
    0,    0,  148,  149,
};
static const short parsercheck[] = {                     37,
    0,   41,   44,   41,   42,   43,   44,   45,   46,   47,
   40,   10,   32,   46,   33,  261,   35,   44,   37,  261,
   58,   59,   60,   42,   62,   63,   40,   33,   58,   35,
   29,   37,   16,   33,   17,   35,   42,   37,  260,   37,
   59,   24,   42,   41,   42,   43,   44,   45,   32,   47,
   40,   93,   40,   91,   40,   93,  125,  261,   91,   59,
   58,   59,   60,   37,   62,   63,   93,   41,   42,   43,
   44,   45,   92,   47,   41,   61,   41,   44,   62,   44,
   41,   40,   61,   44,   58,   59,   60,   41,   62,   63,
   44,   41,   37,   44,   44,   93,   41,   42,   43,   44,
   45,   37,   47,   44,  123,   44,   42,   43,   92,   45,
   46,   47,   93,   58,   59,   60,  261,   62,   63,   93,
   41,   41,   58,  123,   60,  125,   62,   63,   37,   93,
   61,   59,   41,   42,   43,   44,   45,   46,   47,    0,
   37,   41,  141,   41,   44,   42,   44,  125,   93,   46,
   47,   60,   41,   62,   63,   91,   93,   93,   37,   40,
   58,   59,   41,   42,   43,   37,   45,   46,   47,   93,
   42,   43,   41,   45,   46,   47,   41,   58,  130,   44,
   61,   60,   91,   62,   63,   59,   41,   59,   60,   44,
   62,   63,   37,   39,   91,   93,   67,   42,   43,   37,
   45,   46,   47,   41,   42,   43,  128,   45,   46,   47,
   29,   -1,   91,   58,   -1,   60,   -1,   62,   63,   91,
   -1,  261,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
  268,  269,  270,  271,  272,  273,    6,    7,    8,   37,
  259,   11,  261,   -1,   42,   43,   91,   45,   46,   47,
   -1,   21,   -1,   91,   -1,  261,   -1,  257,  258,  259,
   58,  261,   60,  263,   62,   63,   -1,   -1,   -1,   -1,
  268,  269,  270,  271,  272,  273,   -1,   37,   -1,   -1,
   -1,   -1,   42,   43,   -1,   45,   46,   47,   41,   -1,
   -1,   44,   -1,   91,  268,  269,  270,  271,  272,  273,
   60,   -1,   62,   63,   -1,   58,   59,   33,   -1,   -1,
   63,   -1,   -1,   -1,   40,   41,   -1,   43,   -1,   45,
   -1,   -1,   -1,  268,  269,  270,  271,  272,  273,   -1,
   -1,   91,  268,  269,  270,  271,  272,  273,   -1,   -1,
   93,   37,   -1,   -1,   -1,   -1,   42,   43,   37,   45,
   46,   47,   -1,   42,   43,   -1,   45,   46,   47,  268,
  269,  270,  271,  272,  273,   91,   -1,   93,   -1,   -1,
   -1,   60,   -1,   62,   63,   37,   -1,   -1,   -1,   -1,
   42,   43,   -1,   45,   46,   47,   -1,   -1,   -1,  268,
  269,  270,  271,  272,  273,   91,  268,  269,  270,  271,
  272,  273,   91,   -1,   93,   33,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   44,   45,   -1,   -1,
   -1,   -1,   -1,  268,  269,  270,  271,  272,  273,   91,
  268,  269,  270,  271,  272,  273,   37,   -1,   -1,   -1,
   -1,   42,   43,   37,   45,   46,   47,   -1,   42,   43,
   -1,   45,   46,   47,   -1,   -1,   -1,   33,   -1,   60,
   -1,   62,   63,   91,   40,   -1,   60,   43,   62,   45,
  268,  269,  270,  271,  272,  273,   37,   -1,   -1,   -1,
   -1,   42,   43,   -1,   45,   46,   47,   33,   33,   35,
   91,   37,   93,   -1,   -1,   40,   42,   91,   43,   60,
   45,   62,   -1,   -1,   -1,   -1,   -1,   -1,  268,  269,
  270,  271,  272,  273,   33,   91,   -1,   93,   -1,  272,
  273,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,
   91,   -1,   -1,   -1,   -1,  261,  262,   33,  264,  265,
  266,  267,   -1,   -1,   40,   -1,   91,   43,   41,   45,
   43,   44,   45,   -1,   -1,   33,   -1,   35,   -1,   37,
   -1,   -1,   -1,   -1,   42,   58,   59,   60,   -1,   62,
   63,   -1,   91,   -1,  270,  271,   -1,  123,   -1,  268,
  269,  270,  271,  272,  273,   -1,   -1,   -1,   41,   -1,
   43,   44,   45,   -1,   41,   91,   43,   44,   45,   -1,
   93,   41,   -1,   -1,   44,   58,   59,   60,   -1,   62,
   63,   58,   59,   60,   -1,   62,   63,   -1,   58,   59,
   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   41,  261,  262,   44,  264,  265,  266,  267,
   93,   41,   -1,   43,   44,   45,   93,  125,   -1,   58,
   59,   -1,   -1,   93,   63,   -1,   -1,   -1,   58,   59,
   60,   -1,   62,   63,   -1,   -1,   -1,  268,  269,  270,
  271,  272,  273,   -1,  268,  269,  270,  271,  272,   41,
   -1,   43,   44,   45,   93,  261,  262,   -1,  264,  265,
  266,  267,   -1,   93,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,   -1,   -1,  268,  269,  270,
  271,   41,   -1,  259,   44,  261,  261,  262,   -1,  264,
  265,  266,  267,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   93,   62,   63,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,  261,  262,   -1,  264,  265,  266,  267,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   33,   -1,
   35,   -1,   37,   93,   -1,  261,  262,   42,  264,  265,
  266,  267,   -1,   -1,   -1,  268,  269,  270,  271,  272,
  273,  259,   41,  261,   59,   44,   93,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   58,   59,   60,   -1,   62,
   63,   -1,   -1,   -1,   -1,  268,  269,  270,  271,  272,
  273,  268,  269,  270,  271,  272,  273,   -1,  268,  269,
  270,  271,  272,  273,   93,   41,   -1,   -1,   44,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,
   -1,   -1,   58,   59,   60,   -1,   62,   63,   33,   -1,
   35,   -1,   37,   -1,  273,   -1,   -1,   42,  268,  269,
  270,  271,  272,  273,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   64,   -1,   66,   59,   -1,   -1,   93,   71,   -1,
   73,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  268,  269,  270,  271,
  272,  273,   -1,   96,   -1,   -1,   -1,  100,   -1,   -1,
   -1,   -1,   -1,  106,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  268,  269,
  270,  271,  272,  273,   -1,   -1,   -1,   -1,  123,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  268,  269,   -1,   -1,  272,  273,   -1,   -1,   -1,
   20,   -1,   22,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,   -1,  261,   -1,  263,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   46,   47,   48,   49,
   50,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  268,
  269,   -1,   -1,  272,  273,  268,  269,   -1,   -1,  272,
  273,   -1,   -1,   -1,   -1,   -1,   76,   77,   78,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
   90,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   99,
   -1,   -1,   -1,   -1,   -1,  105,   -1,   -1,   -1,   -1,
   -1,   -1,  268,  269,   -1,   -1,  272,  273,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  135,  261,  137,   -1,   -1,
   -1,   -1,  142,  143,
};
#define YYFINAL 12
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 273
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,"'#'",0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,
0,0,0,0,0,0,0,"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_MODULE","TOK_FUNCTION",
"TOK_IF","TOK_ELSE","TOK_ID","TOK_STRING","TOK_USE","TOK_NUMBER","TOK_TRUE",
"TOK_FALSE","TOK_UNDEF","LE","GE","EQ","NE","AND","OR",
};
static const char *yyrule[] = {
"$accept : input",
"input :",
"$$1 :",
"input : TOK_USE $$1 input",
"input : statement input",
"inner_input :",
"inner_input : statement inner_input",
"statement : ';'",
"statement : '{' inner_input '}'",
"statement : module_instantiation",
"statement : TOK_ID '=' expr ';'",
"$$2 :",
"statement : TOK_MODULE TOK_ID '(' arguments_decl optional_commas ')' $$2 statement",
"$$3 :",
"statement : TOK_FUNCTION TOK_ID '(' arguments_decl optional_commas ')' '=' expr $$3 ';'",
"children_instantiation : module_instantiation",
"children_instantiation : '{' module_instantiation_list '}'",
"if_statement : TOK_IF '(' expr ')' children_instantiation",
"ifelse_statement : if_statement",
"ifelse_statement : if_statement TOK_ELSE children_instantiation",
"module_instantiation : single_module_instantiation ';'",
"module_instantiation : single_module_instantiation children_instantiation",
"module_instantiation : ifelse_statement",
"module_instantiation_list :",
"module_instantiation_list : module_instantiation_list module_instantiation",
"single_module_instantiation : TOK_ID '(' arguments_call ')'",
"single_module_instantiation : TOK_ID ':' single_module_instantiation",
"single_module_instantiation : '!' single_module_instantiation",
"single_module_instantiation : '#' single_module_instantiation",
"single_module_instantiation : '%' single_module_instantiation",
"single_module_instantiation : '*' single_module_instantiation",
"expr : TOK_TRUE",
"expr : TOK_FALSE",
"expr : TOK_UNDEF",
"expr : TOK_ID",
"expr : expr '.' TOK_ID",
"expr : TOK_STRING",
"expr : TOK_NUMBER",
"expr : '[' expr ':' expr ']'",
"expr : '[' expr ':' expr ':' expr ']'",
"expr : '[' optional_commas ']'",
"expr : '[' vector_expr optional_commas ']'",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr '%' expr",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr '<' expr",
"expr : expr LE expr",
"expr : expr EQ expr",
"expr : expr NE expr",
"expr : expr GE expr",
"expr : expr '>' expr",
"expr : expr AND expr",
"expr : expr OR expr",
"expr : '+' expr",
"expr : '-' expr",
"expr : '!' expr",
"expr : '(' expr ')'",
"expr : expr '?' expr ':' expr",
"expr : expr '[' expr ']'",
"expr : TOK_ID '(' arguments_call ')'",
"optional_commas : ',' optional_commas",
"optional_commas :",
"vector_expr : expr",
"vector_expr : vector_expr ',' optional_commas expr",
"arguments_decl :",
"arguments_decl : argument_decl",
"arguments_decl : arguments_decl ',' optional_commas argument_decl",
"argument_decl : TOK_ID",
"argument_decl : TOK_ID '=' expr",
"arguments_call :",
"arguments_call : argument_call",
"arguments_call : arguments_call ',' optional_commas argument_call",
"argument_call : expr",
"argument_call : TOK_ID '=' expr",

};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;

#define YYPURE 0

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 561 "src/parser.y"

int parserlex(void)
{
	return lexerlex();
}

void yyerror (char const *s)
{
	// FIXME: We leak memory on parser errors...
	PRINTF("Parser error in line %d: %s\n", lexerget_lineno(), s);
	module = NULL;
}

extern FILE *lexerin;
extern const char *parser_input_buffer;
const char *parser_input_buffer;
const char *parser_source_path;

AbstractModule *parse(const char *text, const char *path, int debug)
{
	lexerin = NULL;
	parser_error_pos = -1;
	parser_input_buffer = text;
	parser_source_path = path;

	module_stack.clear();
	module = new Module();

	parserdebug = debug;
	parserparse();

	lexerlex_destroy();

	if (!module)
		return NULL;

	QHashIterator<QString, Module*> i(module->usedlibs);
	while (i.hasNext()) {
		i.next();
		module->usedlibs[i.key()] = Module::compile_library(i.key());
		if (!module->usedlibs[i.key()]) {
			PRINTF("WARNING: Failed to compile library `%s'.", i.key().toUtf8().data());
			module->usedlibs.remove(i.key());
		}
	}

	parser_error_pos = -1;
	return module;
}

QHash<QString, Module::libs_cache_ent> Module::libs_cache;

Module *Module::compile_library(QString filename)
{
	struct stat st;
	memset(&st, 0, sizeof(struct stat));
	stat(filename.toAscii().data(), &st);

	QString cache_id;
	cache_id.sprintf("%x.%x", (int)st.st_mtime, (int)st.st_size);

	if (libs_cache.contains(filename) && libs_cache[filename].cache_id == cache_id) {
		PRINT(libs_cache[filename].msg);
		return &(*libs_cache[filename].mod);
	}

	QFile f(filename);
	if (!f.open(QIODevice::ReadOnly | QIODevice::Text)) {
		PRINTF("WARNING: Can't open library file `%s'.", filename.toUtf8().data());
		return NULL;
	}
	QString text = QTextStream(&f).readAll();

	print_messages_push();

	PRINTF("Compiling library `%s'.", filename.toUtf8().data());
	libs_cache_ent e = { NULL, cache_id, QString("WARNING: Library `%1' tries to recursively use itself!").arg(filename) };
	if (libs_cache.contains(filename))
		delete libs_cache[filename].mod;
	libs_cache[filename] = e;

	Module *backup_mod = module;
	Module *lib_mod = dynamic_cast<Module*>(parse(text.toLocal8Bit(), QFileInfo(filename).absoluteDir().absolutePath().toLocal8Bit(), 0));
	module = backup_mod;

	if (lib_mod) {
		libs_cache[filename].mod = lib_mod;
		libs_cache[filename].msg = print_messages_stack.last();
	} else {
		libs_cache.remove(filename);
	}

	print_messages_pop();

	return lib_mod;
}

#line 728 "parser.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (data->s_base != 0)
          ? (short *)realloc(data->s_base, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base  = newss;
    data->s_mark = newss + i;

    newvs = (data->l_base != 0)
          ? (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 2:
#line 133 "src/parser.y"
	{ module->usedlibs[yystack.l_mark[0].text] = NULL; }
break;
case 9:
#line 143 "src/parser.y"
	{
		if (yystack.l_mark[0].inst) {
			module->children.append(yystack.l_mark[0].inst);
		} else {
			delete yystack.l_mark[0].inst;
		}
	}
break;
case 10:
#line 150 "src/parser.y"
	{
		bool add_new_assignment = true;
		for (int i = 0; i < module->assignments_var.size(); i++) {
			if (module->assignments_var[i] != QString(yystack.l_mark[-3].text))
				continue;
			delete module->assignments_expr[i];
			module->assignments_expr[i] = yystack.l_mark[-1].expr;
			add_new_assignment = false;
		}
		if (add_new_assignment) {
			module->assignments_var.append(yystack.l_mark[-3].text);
			module->assignments_expr.append(yystack.l_mark[-1].expr);
			free(yystack.l_mark[-3].text);
		}
	}
break;
case 11:
#line 165 "src/parser.y"
	{
		Module *p = module;
		module_stack.append(module);
		module = new Module();
		p->modules[yystack.l_mark[-4].text] = module;
		module->argnames = yystack.l_mark[-2].args->argnames;
		module->argexpr = yystack.l_mark[-2].args->argexpr;
		free(yystack.l_mark[-4].text);
		delete yystack.l_mark[-2].args;
	}
break;
case 12:
#line 174 "src/parser.y"
	{
		module = module_stack.last();
		module_stack.pop_back();
	}
break;
case 13:
#line 178 "src/parser.y"
	{
		Function *func = new Function();
		func->argnames = yystack.l_mark[-4].args->argnames;
		func->argexpr = yystack.l_mark[-4].args->argexpr;
		func->expr = yystack.l_mark[0].expr;
		module->functions[yystack.l_mark[-6].text] = func;
		free(yystack.l_mark[-6].text);
		delete yystack.l_mark[-4].args;
	}
break;
case 15:
#line 190 "src/parser.y"
	{
		yyval.inst = new ModuleInstantiation();
		if (yystack.l_mark[0].inst) {
			yyval.inst->children.append(yystack.l_mark[0].inst);
		} else {
			delete yystack.l_mark[0].inst;
		}
	}
break;
case 16:
#line 198 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[-1].inst;
	}
break;
case 17:
#line 203 "src/parser.y"
	{
		yyval.ifelse = new IfElseModuleInstantiation();
		yyval.ifelse->modname = "if";
		yyval.ifelse->argnames.append(QString());
		yyval.ifelse->argexpr.append(yystack.l_mark[-2].expr);

		if (yyval.ifelse) {
			yyval.ifelse->children = yystack.l_mark[0].inst->children;
		} else {
			for (int i = 0; i < yystack.l_mark[0].inst->children.count(); i++)
				delete yystack.l_mark[0].inst->children[i];
		}
		yystack.l_mark[0].inst->children.clear();
		delete yystack.l_mark[0].inst;
	}
break;
case 18:
#line 220 "src/parser.y"
	{
		yyval.ifelse = yystack.l_mark[0].ifelse;
	}
break;
case 19:
#line 223 "src/parser.y"
	{
		yyval.ifelse = yystack.l_mark[-2].ifelse;
		if (yyval.ifelse) {
			yyval.ifelse->else_children = yystack.l_mark[0].inst->children;
		} else {
			for (int i = 0; i < yystack.l_mark[0].inst->children.count(); i++)
				delete yystack.l_mark[0].inst->children[i];
		}
		yystack.l_mark[0].inst->children.clear();
		delete yystack.l_mark[0].inst;
	}
break;
case 20:
#line 236 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[-1].inst;
	}
break;
case 21:
#line 239 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[-1].inst;
		if (yyval.inst) {
			yyval.inst->children = yystack.l_mark[0].inst->children;
		} else {
			for (int i = 0; i < yystack.l_mark[0].inst->children.count(); i++)
				delete yystack.l_mark[0].inst->children[i];
		}
		yystack.l_mark[0].inst->children.clear();
		delete yystack.l_mark[0].inst;
	}
break;
case 22:
#line 250 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[0].ifelse;
	}
break;
case 23:
#line 255 "src/parser.y"
	{
		yyval.inst = new ModuleInstantiation();
	}
break;
case 24:
#line 258 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[-1].inst;
		if (yyval.inst) {
			if (yystack.l_mark[0].inst)
				yyval.inst->children.append(yystack.l_mark[0].inst);
		} else {
			delete yystack.l_mark[0].inst;
		}
	}
break;
case 25:
#line 269 "src/parser.y"
	{
		yyval.inst = new ModuleInstantiation();
		yyval.inst->modname = QString(yystack.l_mark[-3].text);
		yyval.inst->argnames = yystack.l_mark[-1].args->argnames;
		yyval.inst->argexpr = yystack.l_mark[-1].args->argexpr;
		free(yystack.l_mark[-3].text);
		delete yystack.l_mark[-1].args;
	}
break;
case 26:
#line 277 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[0].inst;
		if (yyval.inst)
			yyval.inst->label = QString(yystack.l_mark[-2].text);
		free(yystack.l_mark[-2].text);
	}
break;
case 27:
#line 283 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[0].inst;
		if (yyval.inst)
			yyval.inst->tag_root = true;
	}
break;
case 28:
#line 288 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[0].inst;
		if (yyval.inst)
			yyval.inst->tag_highlight = true;
	}
break;
case 29:
#line 293 "src/parser.y"
	{
		yyval.inst = yystack.l_mark[0].inst;
		if (yyval.inst)
			yyval.inst->tag_background = true;
	}
break;
case 30:
#line 298 "src/parser.y"
	{
		delete yystack.l_mark[0].inst;
		yyval.inst = NULL;
	}
break;
case 31:
#line 304 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "C";
		yyval.expr->const_value = new Value(true);
	}
break;
case 32:
#line 309 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "C";
		yyval.expr->const_value = new Value(false);
	}
break;
case 33:
#line 314 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "C";
		yyval.expr->const_value = new Value();
	}
break;
case 34:
#line 319 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "L";
		yyval.expr->var_name = QString(yystack.l_mark[0].text);
		free(yystack.l_mark[0].text);
	}
break;
case 35:
#line 325 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "N";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->var_name = QString(yystack.l_mark[0].text);
		free(yystack.l_mark[0].text);
	}
break;
case 36:
#line 332 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "C";
		yyval.expr->const_value = new Value(QString(yystack.l_mark[0].text));
		free(yystack.l_mark[0].text);
	}
break;
case 37:
#line 338 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "C";
		yyval.expr->const_value = new Value(yystack.l_mark[0].number);
	}
break;
case 38:
#line 343 "src/parser.y"
	{
		Expression *e_one = new Expression();
		e_one->type = "C";
		e_one->const_value = new Value(1.0);
		yyval.expr = new Expression();
		yyval.expr->type = "R";
		yyval.expr->children.append(yystack.l_mark[-3].expr);
		yyval.expr->children.append(e_one);
		yyval.expr->children.append(yystack.l_mark[-1].expr);
	}
break;
case 39:
#line 353 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "R";
		yyval.expr->children.append(yystack.l_mark[-5].expr);
		yyval.expr->children.append(yystack.l_mark[-3].expr);
		yyval.expr->children.append(yystack.l_mark[-1].expr);
	}
break;
case 40:
#line 360 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "C";
		yyval.expr->const_value = new Value();
		yyval.expr->const_value->type = Value::VECTOR;
	}
break;
case 41:
#line 366 "src/parser.y"
	{
		yyval.expr = yystack.l_mark[-2].expr;
	}
break;
case 42:
#line 369 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "*";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 43:
#line 375 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "/";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 44:
#line 381 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "%";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 45:
#line 387 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "+";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 46:
#line 393 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "-";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 47:
#line 399 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "<";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 48:
#line 405 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "<=";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 49:
#line 411 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "==";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 50:
#line 417 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "!=";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 51:
#line 423 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = ">=";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 52:
#line 429 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = ">";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 53:
#line 435 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "&&";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 54:
#line 441 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "||";
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 55:
#line 447 "src/parser.y"
	{
		yyval.expr = yystack.l_mark[0].expr;
	}
break;
case 56:
#line 450 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "I";
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 57:
#line 455 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "!";
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 58:
#line 460 "src/parser.y"
	{
		yyval.expr = yystack.l_mark[-1].expr;
	}
break;
case 59:
#line 463 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "?:";
		yyval.expr->children.append(yystack.l_mark[-4].expr);
		yyval.expr->children.append(yystack.l_mark[-2].expr);
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 60:
#line 470 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "[]";
		yyval.expr->children.append(yystack.l_mark[-3].expr);
		yyval.expr->children.append(yystack.l_mark[-1].expr);
	}
break;
case 61:
#line 476 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = "F";
		yyval.expr->call_funcname = QString(yystack.l_mark[-3].text);
		yyval.expr->call_argnames = yystack.l_mark[-1].args->argnames;
		yyval.expr->children = yystack.l_mark[-1].args->argexpr;
		free(yystack.l_mark[-3].text);
		delete yystack.l_mark[-1].args;
	}
break;
case 64:
#line 490 "src/parser.y"
	{
		yyval.expr = new Expression();
		yyval.expr->type = 'V';
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 65:
#line 495 "src/parser.y"
	{
		yyval.expr = yystack.l_mark[-3].expr;
		yyval.expr->children.append(yystack.l_mark[0].expr);
	}
break;
case 66:
#line 501 "src/parser.y"
	{
		yyval.args = new ArgsContainer();
	}
break;
case 67:
#line 504 "src/parser.y"
	{
		yyval.args = new ArgsContainer();
		yyval.args->argnames.append(yystack.l_mark[0].arg->argname);
		yyval.args->argexpr.append(yystack.l_mark[0].arg->argexpr);
		delete yystack.l_mark[0].arg;
	}
break;
case 68:
#line 510 "src/parser.y"
	{
		yyval.args = yystack.l_mark[-3].args;
		yyval.args->argnames.append(yystack.l_mark[0].arg->argname);
		yyval.args->argexpr.append(yystack.l_mark[0].arg->argexpr);
		delete yystack.l_mark[0].arg;
	}
break;
case 69:
#line 518 "src/parser.y"
	{
		yyval.arg = new ArgContainer();
		yyval.arg->argname = QString(yystack.l_mark[0].text);
		yyval.arg->argexpr = NULL;
		free(yystack.l_mark[0].text);
	}
break;
case 70:
#line 524 "src/parser.y"
	{
		yyval.arg = new ArgContainer();
		yyval.arg->argname = QString(yystack.l_mark[-2].text);
		yyval.arg->argexpr = yystack.l_mark[0].expr;
		free(yystack.l_mark[-2].text);
	}
break;
case 71:
#line 532 "src/parser.y"
	{
		yyval.args = new ArgsContainer();
	}
break;
case 72:
#line 535 "src/parser.y"
	{
		yyval.args = new ArgsContainer();
		yyval.args->argnames.append(yystack.l_mark[0].arg->argname);
		yyval.args->argexpr.append(yystack.l_mark[0].arg->argexpr);
		delete yystack.l_mark[0].arg;
	}
break;
case 73:
#line 541 "src/parser.y"
	{
		yyval.args = yystack.l_mark[-3].args;
		yyval.args->argnames.append(yystack.l_mark[0].arg->argname);
		yyval.args->argexpr.append(yystack.l_mark[0].arg->argexpr);
		delete yystack.l_mark[0].arg;
	}
break;
case 74:
#line 549 "src/parser.y"
	{
		yyval.arg = new ArgContainer();
		yyval.arg->argexpr = yystack.l_mark[0].expr;
	}
break;
case 75:
#line 553 "src/parser.y"
	{
		yyval.arg = new ArgContainer();
		yyval.arg->argname = QString(yystack.l_mark[-2].text);
		yyval.arg->argexpr = yystack.l_mark[0].expr;
		free(yystack.l_mark[-2].text);
	}
break;
#line 1515 "parser.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
